window.Gleam.initSearch([{"doc":"transparent_http","title":"transparent_http","content":"# transparent_http\n\n[![Package Version](https://img.shields.io/hexpm/v/transparent_http)](https://hex.pm/packages/transparent_http)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/transparent_http/)\n\nSimple HTTP Client for low level use cases\n\n## Quick start\n1. Add `transparent_http` and a http client which uses `gleam_http` types\n```\ngleam add transparent_http gleam_httpc\n```\n\n2. Create a client\n```gleam\nimport transparent_http\nimport gleam/httpc\n\n\nlet client = transparent_http.default(httpc.send, &quot;&quot;)\n```\n\n3. Send a request\n```gleam\nlet res = client\n|&gt; transparent_http.req(fn (req) {\n    req\n    |&gt; request.set_host(&quot;https://gleam.run&quot;)\n    |&gt; request.set_path(&quot;/health&quot;)\n})\n```\n","url":"index.html"},{"doc":"transparent_http","title":"TransparentHttp","content":"pub type TransparentHttp(body, error) {\n  TransparentHttp(\n    setup_request: fn(Request(body)) -&gt; Request(body),\n    base_request: Request(body),\n    sender: fn(Request(body)) -&gt; Result(Response(body), error),\n  )\n}\n\nTransparentHttp(\n  setup_request: fn(Request(body)) -&gt; Request(body),\n  base_request: Request(body),\n  sender: fn(Request(body)) -&gt; Result(Response(body), error),\n)\n\n\nSynonyms:\ntransparent_http.TransparentHttp\ntransparent_http TransparentHttp","url":"transparent_http.html#TransparentHttp"},{"doc":"transparent_http","title":"TransparentHttpBuilder","content":"pub type TransparentHttpBuilder(body, error) {\n  TransparentHttpBuilder(\n    setup_request: Option(fn(Request(body)) -&gt; Request(body)),\n    base_request: Option(Request(body)),\n    initial_req_body: body,\n    sender: fn(Request(body)) -&gt; Result(Response(body), error),\n  )\n}\n\nTransparentHttpBuilder(\n  setup_request: Option(fn(Request(body)) -&gt; Request(body)),\n  base_request: Option(Request(body)),\n  initial_req_body: body,\n  sender: fn(Request(body)) -&gt; Result(Response(body), error),\n)\n\nsetup_request\n&lt;p&gt;Function that is applied to the &lt;code&gt;base_request&lt;/code&gt; before being passed\nto the &lt;code&gt;req&lt;/code&gt; function&lt;/p&gt;\n\nbase_request\n&lt;p&gt;Base request for contant values e.g. auth headers&lt;/p&gt;\n\ninitial_req_body\n&lt;p&gt;Initial value for request body, e.g. &lt;code&gt;&amp;quot;&amp;quot;&lt;/code&gt;&lt;/p&gt;\n\nsender\n&lt;p&gt;Function that sends a request and gets a response&lt;/p&gt;\n\nSynonyms:\ntransparent_http.TransparentHttpBuilder\ntransparent_http TransparentHttpBuilder","url":"transparent_http.html#TransparentHttpBuilder"},{"doc":"transparent_http","title":"default","content":"pub fn default(sender: fn(Request(a)) -&gt; Result(Response(a), b), initial_request_body: a) -&gt; TransparentHttp(\n  a,\n  b,\n)\n Creates a default TransparentHttp client\nSynonyms:\ntransparent_http.default\ntransparent_http default","url":"transparent_http.html#default"},{"doc":"transparent_http","title":"new","content":"pub fn new(builder: TransparentHttpBuilder(a, b)) -&gt; TransparentHttp(\n  a,\n  b,\n)\n Creates a new TransparentHttp client, taking overrides from the\n TransparentHttpBuilder\nSynonyms:\ntransparent_http.new\ntransparent_http new","url":"transparent_http.html#new"},{"doc":"transparent_http","title":"new_builder","content":"pub fn new_builder(sender: fn(Request(a)) -&gt;\n    Result(Response(a), b), initial_request_body: a) -&gt; TransparentHttpBuilder(\n  a,\n  b,\n)\n\nSynonyms:\ntransparent_http.new_builder\ntransparent_http new_builder","url":"transparent_http.html#new_builder"},{"doc":"transparent_http","title":"req","content":"pub fn req(client: TransparentHttp(a, b), request: fn(Request(a)) -&gt;\n    Request(a)) -&gt; Result(Response(a), b)\n Sends a request via the client&#39;s `sender`, the flow is as follows:\n 1. Take client&#39;s `base_request`\n 2. Pass to the `setup_request` function\n 3. Pass to the `request` parameter\n 4. Return the reponse from `sender`\nSynonyms:\ntransparent_http.req\ntransparent_http req","url":"transparent_http.html#req"},{"doc":"transparent_http","title":"transparent_http","content":"","url":"transparent_http.html"}]);